program hermite_polynomial
  implicit none
  integer,parameter :: rk=selected_real_kind(12,100)

  real(rk),allocatable :: cx(:)
  real(rk) :: x,x1,x2,dx
  integer :: iargc,n,i,imax,k
  character(len=80) :: argu,file1,file2

  if (iargc()/=4) then
     write(0,'(a)') 'usage: hermite_poly x1 x2 dx n'
     stop
  end if

  call getarg(1,argu); read(argu,*) x1
  call getarg(2,argu); read(argu,*) x2
  call getarg(3,argu); read(argu,*) dx
  call getarg(4,argu); read(argu,*) n

  allocate(cx(0:n))

  imax=(x2-x1)/dx+1

  do i=0,imax
     x=x1+dx*i
     call hermite_poly(n,x,cx)
     do k=0,n
        write(10+k,*) x,cx(k)
     end do
  end do


end program hermite_polynomial
