program neville

! gawk 'BEGIN {for (x=0;x<=2*atan2(1,1);x+=0.2) print x,sin(x)}'

  implicit none
  integer,parameter :: rk=selected_real_kind(15,100)

  real(rk),allocatable :: xa(:),ya(:),s(:,:)
  real(rk) ::  x,y,x1,x2,dx
  integer :: n,i,j,ix,ixmax
  character(len=80) :: argu

  if (iargc()/=3) then
     call getarg(0,argu)
     write(0,'(a,a,a)') 'usage: ',trim(argu),' x1 x2 dx'
     stop
  end if

  call getarg(1,argu); read(argu,*) x1
  call getarg(2,argu); read(argu,*) x2
  call getarg(3,argu); read(argu,*) dx

  read(5,*) n
  allocate(xa(n),ya(n),s(n,0:n-1))
  do i=1,n
     read(5,*) xa(i),ya(i)
  end do

  s(1:n,0)=ya

  ixmax=(x2-x1)/dx
  
  do ix=0,ixmax
     x=x1+dx*ix
     do j=1,n-1
        do i=1,n-j
           s(i,j)=((x-xa(i+j))*s(i,j-1)+(xa(i)-x)*s(i+1,j-1))/(xa(i)-xa(i+j))
        end do
     end do
     write(6,*) x,s(1,n-1)
  end do

  stop
end program neville
  
