program main

!*******************************************************************************
!
!! POLPAK_PRB calls the POLPAK test routines.
!
  implicit none

  call timestamp ( )

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'POLPAK_PRB'
  write ( *, '(a)' ) '  Tests for the FORTRAN90 POLPAK library.'

  call test001
  call test002
  call test003
  call test0035
  call test004
  call test005
  call test006
  call test007
  call test008
  call test010
  call test0102
  call test0104

  call test011
  call test0115
  call test012
  call test013
  call test014
  call test015
  call test016
  call test017
  call test0175
  call test018
  call test0185
  call test019
  call test020

  call test021
  call test0215
  call test022
  call test023
  call test024
  call test01155
  call test0116
  call test0245
  call test025
  call test026
  call test0265
  call test028
  call test027
  call test029

  call test031
  call test032
  call test033
  call test034
  call test035
  call test036
  call test037
  call test038
  call test039
  call test040

  call test041
  call test042
  call test043
  call test044
  call test045
  call test046
  call test047
  call test048
  call test049
  call test050

  call test051
  call test052
  call test054
  call test055
  call test057
  call test058
  call test059
  call test060

  call test061
  call test062
  call test063
  call test0635
  call test064
  call test065
  call test066
  call test067
  call test0685
  call test069
  call test0695
  call test070

  call test071
  call test072
  call test073
  call test074
  call test075
  call test076
  call test077
  call test078

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'POLPAK_PRB'
  write ( *, '(a)' ) '  Normal end of execution.'

  write ( *, '(a)' ) ' '
  call timestamp ( )

  stop
end
subroutine test001

!*******************************************************************************
!
!! TEST001 tests ACOSH2.
!
  implicit none

  real ( kind = 8 ) a
  real ( kind = 8 ) acosh2
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ) x2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST001'
  write ( *, '(a)' ) '  ACOSH2 computes the inverse hyperbolic cosine'
  write ( *, '(a)' ) '  of a given value.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    X     ACOSH2(X)     COSH(ACOSH2(X))'
  write ( *, '(a)' ) ' '

  do i = 0, 10
    x = 1.0D+00 + real ( i, kind = 8 ) / 5.0D+00
    a = acosh2 ( x )
    x2 = cosh ( a )
    write ( *, '(2x,3g14.6)' ) x, a, x2
  end do

  return
end
subroutine test002

!*******************************************************************************
!
!! TEST002 tests AGUD.
!! TEST002 tests GUD.
!
  implicit none

  real ( kind = 8 ) agud
  real ( kind = 8 ) gamma
  real ( kind = 8 ) gud
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ) x2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST002'
  write ( *, '(a)' ) '  AGUD computes the inverse Gudermannian;'
  write ( *, '(a)' ) '  GUD computes the Gudermannian.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    X     GUD(X)     AGUD(GUD(X))'
  write ( *, '(a)' ) ' '

  do i = 0, 10
    x = 1.0D+00 + real ( i, kind = 8 ) / 5.0D+00
    gamma = gud ( x )
    x2 = agud ( gamma )
    write ( *, '(2x,3g14.6)' ) x, gamma, x2
  end do

  return
end
subroutine test003

!*******************************************************************************
!
!! TEST003 tests ALIGN_ENUM.
!
  implicit none

  integer, parameter :: m_max = 10
  integer, parameter :: n_max = 10

  integer align_enum
  integer i
  integer j
  integer table(0:m_max,0:n_max)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST003'
  write ( *, '(a)' ) '  ALIGN_ENUM counts the number of possible'
  write ( *, '(a)' ) '  alignments of two biological sequences.'

  do i = 0, m_max
    do j = 0, n_max
      table(i,j) = align_enum ( i, j )
    end do
  end do

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Alignment enumeration table:'
  write ( *, '(a)' ) ' '
  write ( *, '(4x,5i5,6i8)' ) ( i, i = 0, n_max )
  write ( *, '(a)' ) ' '
  do i = 0, m_max
    write ( *, '(2x,i2,5i5,6i8)' ) i, table(i,0:n_max)
  end do

  return
end
subroutine test0035

!*******************************************************************************
!
!! TEST0035 tests ARC_COSINE.
!
  implicit none

  real ( kind = 8 ) a
  real ( kind = 8 ) arc_cosine
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ) x2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0035'
  write ( *, '(a)' ) '  ARC_COSINE computes the inverse cosine'
  write ( *, '(a)' ) '  of a given value, and chops out of bound arguments.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    X     ARC_COSINE(X)     COS(ARC_COSINE(X))'
  write ( *, '(a)' ) ' '

  do i = -5, 5
    x = 1.0D+00 + real ( i, kind = 8 ) / 5.0D+00
    a = arc_cosine ( x )
    x2 = cos ( a )
    write ( *, '(2x,3g14.6)' ) x, a, x2
  end do

  return
end
subroutine test004

!*******************************************************************************
!
!! TEST004 tests ASINH2.
!
  implicit none

  real ( kind = 8 ) a
  real ( kind = 8 ) asinh2
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ) x2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST004'
  write ( *, '(a)' ) '  ASINH2 computes the inverse hyperbolic sine'
  write ( *, '(a)' ) '  of a given value.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  X     ASINH2(X)     SINH(ASINH2(X))'
  write ( *, '(a)' ) ' '

  do i = 0, 10
    x = 1.0D+00 + real ( i, kind = 8 ) / 5.0D+00
    a = asinh2 ( x )
    x2 = sinh ( a )
    write ( *, '(2x,3g14.6)' ) x, a, x2
  end do

  return
end
subroutine test005

!*******************************************************************************
!
!! TEST005 tests ATAN4.
!
  implicit none

  integer, parameter :: ntest = 8

  real ( kind = 8 ) atan4
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ), dimension ( ntest ) :: xtest = (/ &
     1.0D+00,  1.0D+00, 0.0D+00, -1.0D+00, &
    -1.0D+00, -1.0D+00, 0.0D+00,  1.0D+00 /)
  real ( kind = 8 ) y
  real ( kind = 8 ), dimension ( ntest ) :: ytest = (/ &
    0.0D+00,  1.0D+00,  1.0D+00,  1.0D+00, &
    0.0D+00, -1.0D+00, -1.0D+00, -1.0D+00 /)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST005'
  write ( *, '(a)' ) '  ATAN4 computes the arc-tangent given Y and X;'
  write ( *, '(a)' ) '  ATAN2 is the system version of this routine.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  X     Y     ATAN2(Y,X)   ATAN4(Y,X)'
  write ( *, '(a)' ) ' '

  do i = 1, ntest
    x = xtest(i)
    y = ytest(i)
    write ( *, '(2x,4g14.6)' ) x, y, atan2 ( y, x ), atan4 ( y, x )
  end do

  return
end
subroutine test006

!*******************************************************************************
!
!! TEST006 tests ATANH2.
!
  implicit none

  real ( kind = 8 ) a
  real ( kind = 8 ) atanh2
  integer i
  real ( kind = 8 ) x
  real ( kind = 8 ) x2

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST006'
  write ( *, '(a)' ) '  ATANH2 computes the inverse hyperbolic tangent'
  write ( *, '(a)' ) '    of a given value.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '      X     ATANH2(X)     TANH(ATANH2(X))'
  write ( *, '(a)' ) ' '

  do i = -2, 9
    x = real ( i, kind = 8 ) / 10.0D+00
    a = atanh2 ( x )
    x2 = tanh ( a )
    write ( *, '(2x,3g14.6)' ) x, a, x2
  end do

  return
end
subroutine test007

!*******************************************************************************
!
!! TEST007 tests BELL.
!! TEST007 tests BELL_VALUES.
!
  implicit none

  integer c
  integer c2(0:10)
  integer n
  integer n_data

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST007'
  write ( *, '(a)' ) '  BELL computes Bell numbers.'
  write ( *, '(a)' ) '  BELL_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N  exact C(I)  computed C(I)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call bell_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call bell ( n, c2 )

    write ( *, '(2x,i4,2i10)' ) n, c, c2(n)

  end do
 
  return
end
subroutine test008

!*******************************************************************************
!
!! TEST008 tests BENFORD.
!
  implicit none

  real ( kind = 8 ) benford
  integer i

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST008'
  write ( *, '(a)' ) '  BENFORD(I) is the Benford probability of the'
  write ( *, '(a)' ) '  initial digit sequence I.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I,  BENFORD(I)'
  write ( *, '(a)' ) ' '

  do i = 1, 9
    write ( *, '(2x,i2,2x,g14.6)' )  i, benford(i)
  end do
 
  return
end
subroutine test010

!*******************************************************************************
!
!! TEST010 tests BERNOULLI;
!! TEST010 tests BERNOULLI_VALUES.
!
  implicit none

  real ( kind = 8 ) c0
  real ( kind = 8 ) c1(0:30)
  integer n
  integer n_data

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST010'
  write ( *, '(a)' ) '  BERNOULLI computes Bernoulli numbers;'
  write ( *, '(a)' ) '  BERNOULLI_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   I      Exact     Bernoulli'
  write ( *, '(a)' ) ' '
  
  n_data = 0

  do

    call bernoulli_values ( n_data, n, c0 )

    if ( n_data == 0 ) then
      exit
    end if

    call bernoulli ( n, c1 )

    write ( *, '(2x,i4,2g14.6)' ) n, c0, c1(n)

  end do
 
  return
end
subroutine test0102

!*******************************************************************************
!
!! TEST0102 tests BERNOULLI2;
!! TEST0102 tests BERNOULLI_VALUES.
!
  implicit none

  real ( kind = 8 ) c0
  real ( kind = 8 ) c1(0:30)
  integer n
  integer n_data

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0102'
  write ( *, '(a)' ) '  BERNOULLI2 computes Bernoulli numbers;'
  write ( *, '(a)' ) '  BERNOULLI_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   I      Exact     Bernoulli2'
  write ( *, '(a)' ) ' '
  
  n_data = 0

  do

    call bernoulli_values ( n_data, n, c0 )

    if ( n_data == 0 ) then
      exit
    end if

    call bernoulli2 ( n, c1 )
 
    write ( *, '(2x,i4,2g14.6)' ) n, c0, c1(n)

  end do
 
  return
end
subroutine test0104

!*******************************************************************************
!
!! TEST0104 tests BERNOULLI3.
!! TEST0104 tests BERNOULLI_VALUES.
!
  implicit none

  real ( kind = 8 ) c0
  real ( kind = 8 ) c1
  integer n
  integer n_data

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0104'
  write ( *, '(a)' ) '  BERNOULLI3 computes Bernoulli numbers.'
  write ( *, '(a)' ) '  BERNOULLI_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   I      Exact     BERNOULLI3'
  write ( *, '(a)' ) ' '
  
  n_data = 0

  do

    call bernoulli_values ( n_data, n, c0 )

    if ( n_data == 0 ) then
      exit
    end if

    call bernoulli3 ( n, c1 )

    write ( *, '(2x,i4,2g14.6)' ) n, c0, c1

  end do
 
  return
end
subroutine test011

!*******************************************************************************
!
!! TEST011 tests BERNOULLI_POLY;
!
  implicit none

  real ( kind = 8 ) bx
  integer i
  integer, parameter :: n = 15
  real ( kind = 8 ) x

  x = 0.2D+00
 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST011'
  write ( *, '(a)' ) '  BERNOULLI_POLY evaluates Bernoulli polynomials;'
  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  X = ', x
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I          BX'
  write ( *, '(a)' ) ' '
 
  do i = 1, n
    call bernoulli_poly ( i, x, bx )
    write ( *, '(2x,i2,2x,g16.8)' ) i, bx
  end do
 
  return
end
subroutine test0115

!*******************************************************************************
!
!! TEST0115 tests BERNOULLI_POLY2.
!
  implicit none

  real ( kind = 8 ) bx
  integer i
  integer, parameter :: n = 15
  real ( kind = 8 ) x

  x = 0.2D+00
 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0115'
  write ( *, '(a)' ) '  BERNOULLI_POLY2 evaluates Bernoulli polynomials. '
  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  X = ', x
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I          BX'
  write ( *, '(a)' ) ' '
 
  do i = 1, n
    call bernoulli_poly2 ( i, x, bx )
    write ( *, '(2x,i2,2x,2g16.8)' ) i, bx
  end do
 
  return
end
subroutine test012

!*******************************************************************************
!
!! TEST012 tests BETA.
!! TEST012 tests BETA_VALUES.
!
  implicit none

  real ( kind = 8 ) beta
  real ( kind = 8 ) fxy
  real ( kind = 8 ) fxy2
  integer n_data
  real ( kind = 8 ) x
  real ( kind = 8 ) y

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST012:'
  write ( *, '(a)' ) '  BETA evaluates the Beta function.'
  write ( *, '(a)' ) '  BETA_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X      Y        Exact F       BETA(X,Y)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call beta_values ( n_data, x, y, fxy )

    if ( n_data == 0 ) then
      exit
    end if

    fxy2 = beta ( x, y )

    write ( *, '(2x,2f8.4,2g14.6)' ) x, y, fxy, fxy2

  end do

  return
end
subroutine test013

!*******************************************************************************
!
!! TEST013 tests BERNSTEIN_POLY.
!! TEST013 tests BERNSTEIN_POLY_VALUES.
!
  implicit none

  real ( kind = 8 ) b
  real ( kind = 8 ) bvec(0:10)
  integer k
  integer n
  integer n_data
  real ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST013:'
  write ( *, '(a)' ) '  BERNSTEIN_POLY evaluates the Bernstein polynomials.'
  write ( *, '(a)' ) '  BERNSTEIN_POLY_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   N   K   X   Exact   B(N,K)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call bernstein_poly_values ( n_data, n, k, x, b )

    if ( n_data == 0 ) then
      exit
    end if

    call bernstein_poly ( n, x, bvec )

    write ( *, '(2x,i4,i4,f7.4,2g14.6)' ) n, k, x, b, bvec(k)

  end do

  return
end
subroutine test014

!*******************************************************************************
!
!! TEST014 tests BPAB.
!
  implicit none

  integer, parameter :: n = 10

  real ( kind = 8 ) a
  real ( kind = 8 ) b
  real ( kind = 8 ) bern(0:n)
  integer i
  real ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST014'
  write ( *, '(a)' ) '  BPAB evaluates Bernstein polynomials.'
  write ( *, '(a)' ) ' '

  x = 0.3D+00
  a = 0.0D+00
  b = 1.0D+00
  call bpab ( n, x, a, b, bern )
 
  write ( *, '(a,i4)' ) '  The Bernstein polynomials of degree ', n
  write ( *, '(a,g14.6)' ) '  based on the interval from ', a
  write ( *, '(a,g14.6)' ) '  to ', b
  write ( *, '(a,g14.6)' ) '  evaluated at X = ', x
  write ( *, '(a)' ) ' '
 
  do i = 0, n
    write ( *, '(2x,i4,2x,g14.6)' )  i, bern(i)
  end do
 
  return
end
subroutine test015

!*******************************************************************************
!
!! TEST015 tests CARDAN.
!! TEST015 tests CARDAN_POLY_COEF.
!
  implicit none

  integer, parameter :: n_max = 10

  real ( kind = 8 ) c(0:n_max)
  real ( kind = 8 ) cx1
  real ( kind = 8 ) cx2(0:n_max)
  integer n
  real ( kind = 8 ) s
  real ( kind = 8 ) x

  s = 1.0E+00

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST015'
  write ( *, '(a)' ) '  CARDAN_POLY_COEF returns the coefficients of a'
  write ( *, '(a)' ) '    Cardan polynomial.'
  write ( *, '(a)' ) '  CARDAN evaluates a Cardan polynomial directly.'
  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  We use the parameter S = ', s
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Table of polynomial coefficients:'
  write ( *, '(a)' ) ' '

  do n = 0, n_max
    call cardan_poly_coef ( n, s, c )
    write ( *, '(2x,i2,11f7.0)' ) n, c(0:n)
  end do

  s = 0.5E+00
  x = 0.25E+00

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Compare CARDAN_POLY_COEF + DPOLY_VAL_HORNER'
  write ( *, '(a)' ) '  versus CARDAN alone.'
  write ( *, '(a)' ) ' '
  write ( *, '(a,g14.6)' ) '  Evaluate polynomials at X = ', x
  write ( *, '(a,g14.6)' ) '  We use the parameter S = ', s
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Order, Horner, Direct'
  write ( *, '(a)' ) ' '

  call cardan ( n, x, s, cx2 )

  do n = 0, n_max

    call cardan_poly_coef ( n, s, c )
    call dpoly_val_horner ( n, c, x, cx1 )

    write ( *, '(2x,i2,2g14.6)' ) n, cx1, cx2(n)

  end do

  return
end
subroutine test016

!*******************************************************************************
!
!! TEST016 tests CATALAN.
!! TEST016 tests CATALAN_VALUES.
!
  implicit none

  integer c
  integer c2(0:10)
  integer n
  integer n_data

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST016'
  write ( *, '(a)' ) '  CATALAN computes Catalan numbers.'
  write ( *, '(a)' ) '  CATALAN_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N  exact C(I)  computed C(I)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call catalan_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call catalan ( n, c2 )

    write ( *, '(2x,i4,2i8)' ) n, c, c2(n)

  end do
 
  return
end
subroutine test017

!*******************************************************************************
!
!! TEST017 tests CATALAN_ROW_NEXT.
!
  implicit none

  integer, parameter :: n = 10

  integer c(0:n)
  integer i
  integer ido
  integer j

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST017'
  write ( *, '(a)' ) '  CATALAN_ROW_NEXT computes a row of Catalan''s triangle.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  First, compute row 7:'

  ido = 0
  i = 7
  call catalan_row_next ( ido, i, c )
  write ( *, '(2x,i2,2x,11i6)' ) i, c(0:i)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Now compute rows one at a time:'
  write ( *, '(a)' ) ' '

  ido = 0
 
  do i = 0, n
    call catalan_row_next ( ido, i, c )
    ido = 1
    write ( *, '(2x,i2,2x,11i6)' ) i, c(0:i)
  end do
 
  return
end
subroutine test0175

!*******************************************************************************
!
!! TEST0175 tests CHARLIER.
!
  implicit none

  integer, parameter :: test_num = 5

  real ( kind = 8 ) a
  real ( kind = 8 ), dimension ( test_num ) :: a_test = (/ &
    0.25D+00, 0.5D+00, 1.0D+00, 2.0D+00, 10.0D+00 /)
  real ( kind = 8 ) charlier
  integer i
  integer n
  integer test
  real ( kind = 8 ) x
  real ( kind = 8 ) value

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0175:'
  write ( *, '(a)' ) '  CHARLIER evaluates a Poisson-Charlier polynomial.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       N      A         X        P(N,A,X)'
  write ( *, '(a)' ) ' '

  do test = 1, test_num

    a = a_test(test)

    write ( *, '(a)' ) ' '

    do i = 0, 5

      x = real ( i, kind = 8 ) / 2.0D+00

      write ( *, '(a)' ) ' '

      do n = 0, 5

        value = charlier ( n, a, x )

        write ( *, '(2x,i6,2x,f8.4,2x,f8.4,2x,g14.6)' ) n, a, x, value

      end do

    end do

  end do

  return
end
subroutine test018

!*******************************************************************************
!
!! TEST018 tests CHEBY_T.
!! TEST018 tests CHEBY_T_VALUES.
!
  implicit none

  integer, parameter :: n_max = 12

  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST018:'
  write ( *, '(a)' ) '  CHEBY_T evaluates the Chebyshev T polynomial.'
  write ( *, '(a)' ) '  CHEBY_T_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       T(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call cheby_t_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call cheby_t ( n, x, fx2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test0185

!*******************************************************************************
!
!! TEST0185 tests CHEBY_T_ZERO.
!
  implicit none

  integer, parameter :: n_max = 4

  real ( kind = 8 ) fx(0:n_max)
  integer i
  integer n
  real ( kind = 8 ) z(n_max)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0185:'
  write ( *, '(a)' ) '  CHEBY_T_ZERO returns zeroes of the T(N)(X).'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       N      X        T(N)(X)'
  write ( *, '(a)' ) ' '

  do n = 1, n_max

    call cheby_t_zero ( n, z )

    do i = 1, n

      call cheby_t ( n, z(i), fx )

      write ( *, '(2x,i6,2x,f8.4,2x,g14.6)' ) n, z(i), fx(n)

    end do

    write ( *, '(a)' ) ' '

  end do

  return
end
subroutine test019

!*******************************************************************************
!
!! TEST019 tests CHEBY_T_POLY_COEF.
!
  implicit none

  integer, parameter :: n = 5

  real ( kind = 8 ) c(0:n,0:n)
  integer i
  integer j

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST019'
  write ( *, '(a)' ) &
    '  CHEBY_T_POLY_COEF determines the Chebyshev T polynomial coefficients.'

  call cheby_t_poly_coef ( n, c )
 
  do i = 0, n
    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  T(', i, ')'
    write ( *, '(a)' ) ' '
    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) c(i,j), ' * x**', j
      end if
    end do
  end do
 
  return
end
subroutine test020

!*******************************************************************************
!
!! TEST020 tests CHEBY_U.
!! TEST020 tests CHEBY_U_VALUES.
!
  implicit none

  integer, parameter :: n_max = 12

  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST020:'
  write ( *, '(a)' ) '  CHEBY_U evaluates the Chebyshev U polynomial.'
  write ( *, '(a)' ) '  CHEBY_U_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       U(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call cheby_u_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call cheby_u ( n, x, fx2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test021

!*******************************************************************************
!
!! TEST021 tests CHEBY_U_POLY_COEF.
!
  implicit none

  integer, parameter :: n = 5

  real ( kind = 8 ) c(0:n,0:n)
  integer i
  integer j

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST021'
  write ( *, '(a)' ) &
    '  CHEBY_U_POLY_COEF determines the Chebyshev U polynomial coefficients.'

  call cheby_u_poly_coef ( n, c )
 
  do i = 0, n
    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  U(', i, ')'
    write ( *, '(a)' ) ' '
    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) c(i,j), ' * x**', j
      end if
    end do
  end do
 
  return
end
subroutine test0215

!*******************************************************************************
!
!! TEST0215 tests CHEBY_U_ZERO.
!
  implicit none

  integer, parameter :: n_max = 4

  real ( kind = 8 ) fx(0:n_max)
  integer i
  integer n
  real ( kind = 8 ) z(n_max)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0215:'
  write ( *, '(a)' ) '  CHEBY_U_ZERO returns zeroes of the U(N)(X).'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       N      X        U(N)(X)'
  write ( *, '(a)' ) ' '

  do n = 1, n_max

    call cheby_u_zero ( n, z )

    do i = 1, n

      call cheby_u ( n, z(i), fx )

      write ( *, '(2x,i6,2x,f8.4,2x,g14.6)' ) n, z(i), fx(n)

    end do

    write ( *, '(a)' ) ' '

  end do

  return
end
subroutine test022

!*******************************************************************************
!
!! TEST022 tests COMBIN.
!
  implicit none

  real ( kind = 8 ) cnk
  integer k
  integer n

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST022'
  write ( *, '(a)' ) '  COMBIN evaluates C(N,K).'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N     K    CNK'
  write ( *, '(a)' ) ' '
 
  do n = 0, 4
    do k = 0, n
      call combin ( n, k, cnk )
      write ( *, '(2x,i6,i6,g14.6)' ) n, k, cnk
    end do
  end do
 
  return
end
subroutine test023

!*******************************************************************************
!
!! TEST023 tests COMBIN2.
!
  implicit none

  integer cnk
  integer k
  integer n

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST023'
  write ( *, '(a)' ) '  COMBIN2 evaluates C(N,K).'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N     K    CNK'
  write ( *, '(a)' ) ' '
 
  do n = 0, 4
    do k = 0, n
      call combin2 ( n, k, cnk )
      write ( *, '(2x,i6,i6,i6)' ) n, k, cnk
    end do
  end do
 
  return
end
subroutine test024

!*******************************************************************************
!
!! TEST024 tests COMB_ROW.
!
  implicit none

  integer, parameter :: n = 10

  integer c(0:n)
  integer i
  integer ido
  integer j

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST024'
  write ( *, '(a)' ) '  COMB_ROW computes a row of Pascal''s triangle.'
  write ( *, '(a)' ) ' '
 
  ido = 0
 
  do i = 0, n
    call comb_row ( ido, i, c )
    ido = 1
    write ( *, '(2x,i2,2x,11i5)' ) i, c(0:i)
  end do
 
  return
end
subroutine test01155
!
!*******************************************************************************
!
!! TEST01155 tests DELANNOY.
!
  implicit none
!
  integer, parameter :: m = 8
  integer, parameter :: n = 8
!
  integer a(0:m,0:n)
  integer i
  integer j
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST01155'
  write ( *, '(a)' ) '  DELANNOY computes the Delannoy numbers A(0:M,0:N).'
  write ( *, '(a)' ) '  A(M,N) counts the paths from (0,0) to (M,N).'
  write ( *, '(a)' ) ' '

  call delannoy ( m, n, a )

  do i = 0, m
    write ( *, '(2x,i4,2x,5i4,3i8,i10)' )  i, a(i,0:n)
  end do
 
  return
end
subroutine test0116
!
!*******************************************************************************
!
!! TEST0116 tests ERF.
!! TEST0116 tests ERF_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  integer n_data
  real ( kind = 8 ) x
  real ( kind = 8 ) x2
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0116'
  write ( *, '(a)' ) '  ERF evaluates the error function.'
  write ( *, '(a)' ) '  ERF_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X      Exact F       D_ERF(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call erf_values ( n_data, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    x2 = dble ( x )
    call erf ( x2, fx2 )

    write ( *, '(2x,f8.4,2g14.6)' ) x, fx, fx2

  end do

  return
end
subroutine test0245
!
!*******************************************************************************
!
!! TEST0245 tests D_FACTORIAL.
!! TEST0245 tests D_FACTORIAL_VALUES.
!
  implicit none
!
  real ( kind = 8 ) d_factorial
  real ( kind = 8 ) fn
  real ( kind = 8 ) fn2
  integer n_data
  integer n
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0245:'
  write ( *, '(a)' ) '  D_FACTORIAL evaluates the factorial function.'
  write ( *, '(a)' ) '  D_FACTORIAL_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N       Exact F       D_FACTORIAL(N)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call d_factorial_values ( n_data, n, fn )

    if ( n_data == 0 ) then
      exit
    end if

    fn2 = d_factorial ( n )

    write ( *, '(2x,i4,2g14.6)' ) n, fn, fn2

  end do

  return
end
subroutine test025
!
!*******************************************************************************
!
!! TEST025 tests ERF.
!! TEST025 tests ERF_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST025:'
  write ( *, '(a)' ) '  ERF evaluates the error function.'
  write ( *, '(a)' ) '  ERF_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X      Exact F       ERF(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call erf_values ( n_data, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call erf ( x, fx2 )

    write ( *, '(2x,f8.4,2g14.6)' ) x, fx, fx2

  end do

  return
end
subroutine test026
!
!*******************************************************************************
!
!! TEST026 tests EULER_NUMBER.
!! TEST026 tests EULER_NUMBER_VALUES.
!
  implicit none
!
  integer c1
  integer c2(0:12)
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST026'
  write ( *, '(a)' ) '  EULER_NUMBER computes Euler numbers.'
  write ( *, '(a)' ) '  EULER_NUMBER_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N  exact   EULER_NUMBER'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call euler_number_values ( n_data, n, c1 )

    if ( n_data == 0 ) then
      exit
    end if

    call euler_number ( n, c2 )

    write ( *, '(2x,i4,2i12,g14.6)' ) n, c1, c2(n)

  end do
 
  return
end
subroutine test0265
!
!*******************************************************************************
!
!! TEST0265 tests EULER_NUMBER2.
!! TEST0265 tests EULER_NUMBER_VALUES.
!
  implicit none
!
  integer c1
  real ( kind = 8 ) c2
  real ( kind = 8 ) euler_number2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0265'
  write ( *, '(a)' ) '  EULER_NUMBER2 computes Euler numbers.'
  write ( *, '(a)' ) '  EULER_NUMBER_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N  exact   EULER_NUMBER2'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call euler_number_values ( n_data, n, c1 )

    if ( n_data == 0 ) then
      exit
    end if

    c2 = euler_number2 ( n )

    write ( *, '(2x,i4,i12,g14.6)' ) n, c1, c2

  end do
 
  return
end
subroutine test028
!
!*******************************************************************************
!
!! TEST028 tests EULER_POLY.
!
  implicit none
!
  real ( kind = 8 ) euler_poly
  real ( kind = 8 ) f
  integer i
  integer, parameter :: n = 15
  real ( kind = 8 ) x
!
  x = 0.5D+00
 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST028'
  write ( *, '(a)' ) '  EULER_POLY evaluates Euler polynomials.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  N         X              F(X)'
  write ( *, '(a)' ) ' '
   
  do i = 0, n
    f = euler_poly ( i, x )
    write ( *, '(2x,i2,2x,2g14.6)' ) i, x, f
  end do
 
  return
end
subroutine test027
!
!*******************************************************************************
!
!!  TEST027 tests EULERIAN.
!
  implicit none
!
  integer, parameter :: n = 7
!
  integer e(n,n)
  integer i
  integer j
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST027'
  write ( *, '(a)' ) '  EULERIAN evaluates Eulerian numbers.'
  write ( *, '(a)' ) ' '
 
  call eulerian ( n, e )

  do i = 1, n
    write ( *, '(2x,10i6)' )  e(i,1:n)
  end do
 
  return
end
subroutine test029
!
!*******************************************************************************
!
!! TEST029 tests F_HOFSTADTER.
!
  implicit none
!
  integer f
  integer f_hofstadter
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST029'
  write ( *, '(a)' ) '  F_HOFSTADTER evaluates Hofstadter''s recursive'
  write ( *, '(a)' ) '  F function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N   F(N)'
  write ( *, '(a)' ) ' '

  do i = 0, 30
    f = f_hofstadter ( i )
    write ( *, '(2x,2i6)' ) i, f
  end do

  return
end
subroutine test031
!
!*******************************************************************************
!
!! TEST031 tests FIBONACCI_DIRECT.
!
  implicit none
!
  integer f
  integer i
  integer n
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST031'
  write ( *, '(a)' ) '  FIBONACCI_DIRECT evalutes a Fibonacci number directly.'
  write ( *, '(a)' ) ' '
 
  n = 20
 
  do i = 1, n
    call fibonacci_direct ( i, f )
    write ( *, '(2x,i6,i10)' ) i, f
  end do
 
  return
end
subroutine test032
!
!*******************************************************************************
!
!! TEST032 tests FIBONACCI_FLOOR.
!
  implicit none
!
  integer f
  integer i
  integer n
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST032'
  write ( *, '(a)' ) '  FIBONACCI_FLOOR computes the largest Fibonacci number'
  write ( *, '(a)' ) '  less than or equal to a given positive integer.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N  Fibonacci  Index'
  write ( *, '(a)' ) ' ' 

  do n = 1, 20
    call fibonacci_floor ( n, f, i )
    write ( *, '(2x,i6,2x,i6,2x,i6)' ) n, f, i
  end do
 
  return
end
subroutine test033
!
!*******************************************************************************
!
!! TEST033 tests FIBONACCI_RECURSIVE.
!
  implicit none
!
  integer, parameter :: n = 20
!
  integer f(n)
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST033'
  write ( *, '(a)' ) '  FIBONACCI_RECURSIVE computes the Fibonacci sequence.'
  write ( *, '(a)' ) ' '
 
  call fibonacci_recursive ( n, f )
 
  do i = 1, n
    write ( *, '(2x,i6,i10)' ) i, f(i)
  end do
 
  return
end
subroutine test034
!
!*******************************************************************************
!
!! TEST034 tests G_HOFSTADTER.
!
  implicit none
!
  integer g
  integer g_hofstadter
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST034'
  write ( *, '(a)' ) '  G_HOFSTADTER evaluates Hofstadter''s recursive'
  write ( *, '(a)' ) '  G function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N   G(N)'
  write ( *, '(a)' ) ' '

  do i = 0, 30
    g = g_hofstadter ( i )
    write ( *, '(2x,2i6)' ) i, g
  end do

  return
end
subroutine test035
!
!*******************************************************************************
!
!! TEST035 tests GAMMA.
!! TEST035 tests GAMMA_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  real ( kind = 8 ) gamma
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST035:'
  write ( *, '(a)' ) '  GAMMA evaluates the Gamma function.'
  write ( *, '(a)' ) '  GAMMA_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X       Exact F       GAMMA(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call gamma_values ( n_data, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    if ( 0.0E+00 < x ) then

      fx2 = gamma ( x )

      write ( *, '(2x,f8.4,2g14.6)' ) x, fx, fx2

    else

      write ( *, '(2x,f8.4,g14.6, a)' ) x, fx, ' (Unavailable)'

    end if

  end do

  return
end
subroutine test036
!
!*******************************************************************************
!
!! TEST036 tests GAMMA_LOG.
!! TEST036 tests GAMMA_LOG_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  real ( kind = 8 ) gamma_log
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST036:'
  write ( *, '(a)' ) '  GAMMA_LOG evaluates the logarithm of the '
  write ( *, '(a)' ) '    Gamma function.'
  write ( *, '(a)' ) '  GAMMA_LOG_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X       Exact F       GAMMA_LOG(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call gamma_log_values ( n_data, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    fx2 = gamma_log ( x )

    write ( *, '(2x,f8.4,2g18.10)' ) x, fx, fx2

  end do

  return
end
subroutine test037
!
!*******************************************************************************
!
!! TEST037 tests GEGENBAUER_POLY.
!! TEST037 tests GEGENBAUER_POLY_VALUES.
!
  implicit none

  real ( kind = 8 ) a
  real ( kind = 8 ), allocatable, dimension ( : ) :: c
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  integer n
  integer n_data
  real ( kind = 8 ) x

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST037:'
  write ( *, '(a)' ) '  GEGENBAUER_POLY computes values of '
  write ( *, '(a)' ) '    the Gegenbauer polynomials.'
  write ( *, '(a)' ) '  GEGENBAUER_POLY_VALUES returns values of '
  write ( *, '(a)' ) '    the Gegenbauer polynomials.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       N       A       X       GPV      GEGENBAUER'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call gegenbauer_poly_values ( n_data, n, a, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    allocate ( c(0:n) )

    call gegenbauer_poly ( n, a, x, c )
    fx2 = c(n)

    write ( *, '(2x,i6,2x,f10.4,2x,f10.4,2g14.6)' ) n, a, x, fx, fx2

    deallocate ( c )

  end do

  return
end
subroutine test038
!
!*******************************************************************************
!
!! TEST038 tests GUD.
!! TEST038 tests GUD_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  real ( kind = 8 ) gud
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST038:'
  write ( *, '(a)' ) '  GUD evaluates the Gudermannian function.'
  write ( *, '(a)' ) '  GUD_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X      Exact F       GUD(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call gud_values ( n_data, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    fx2 = gud ( x )

    write ( *, '(2x,f8.4,2g14.6)' ) x, fx, fx2

  end do

  return
end
subroutine test039
!
!*******************************************************************************
!
!! TEST039 tests HAIL.
!
  implicit none
!
  integer hail
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST039'
  write ( *, '(a)' ) '  HAIL(I) computes the length of the hail sequence'
  write ( *, '(a)' ) '  for I, also known as the 3*N+1 sequence.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I,  HAIL(I)'
  write ( *, '(a)' ) ' '

  do i = 1, 20
    write ( *, '(2x,i4,2x,i6)' )  i, hail(i)
  end do
 
  return
end
subroutine test040
!
!*******************************************************************************
!
!! TEST040 tests H_HOFSTADTER.
!
  implicit none
!
  integer h
  integer h_hofstadter
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST040'
  write ( *, '(a)' ) '  H_HOFSTADTER evaluates Hofstadter''s recursive'
  write ( *, '(a)' ) '  H function.'

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N   H(N)'
  write ( *, '(a)' ) ' '

  do i = 0, 30
    h = h_hofstadter ( i )
    write ( *, '(2x,2i6)' ) i, h
  end do

  return
end
subroutine test041
!
!*******************************************************************************
!
!! TEST041 tests HERMITE_POLY.
!! TEST041 tests HERMITE_POLY_VALUES.
!
  implicit none
!
  integer, parameter :: n_max = 12
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST041:'
  write ( *, '(a)' ) '  HERMITE_POLY evaluates the Hermite polynomial.'
  write ( *, '(a)' ) '  HERMITE_POLY_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       H(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call hermite_poly_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call hermite_poly ( n, x, fx2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test042
!
!*******************************************************************************
!
!! TEST042 tests HERMITE_POLY_COEF.
!
  implicit none
!
  integer, parameter :: n = 5
!
  real ( kind = 8 ) c(0:n,0:n)
  integer i
  integer j
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST042'
  write ( *, '(a)' ) &
    '  HERMITE_POLY_COEF determines the Hermite polynomial coefficients.'

  call hermite_poly_coef ( n, c )
 
  do i = 0, n
    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  H(', i, ')'
    write ( *, '(a)' ) ' '
    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) c(i,j), ' * x**', j
      end if
    end do
  end do
 
  return
end
subroutine test043
!
!*******************************************************************************
!
!! TEST043 tests I_FACTORIAL.
!! TEST043 tests I_FACTORIAL_VALUES.
!
  implicit none
!
  integer fn
  integer fn2
  integer i_factorial
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST043:'
  write ( *, '(a)' ) '  I_FACTORIAL evaluates the factorial function.'
  write ( *, '(a)' ) '  I_FACTORIAL_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     X       Exact F       I_FACTORIAL(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call i_factorial_values ( n_data, n, fn )

    if ( n_data == 0 ) then
      exit
    end if

    fn2 = i_factorial ( n )

    write ( *, '(2x,i4,2i12)' ) n, fn, fn2

  end do

  return
end
subroutine test044
!
!*******************************************************************************
!
!! TEST044 tests I_FACTORIAL2.
!! TEST044 tests I_FACTORIAL2_VALUES.
!
  implicit none
!
  integer fn
  integer fn2
  integer n
  integer n_data
  integer i_factorial2
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST044:'
  write ( *, '(a)' ) '  I_FACTORIAL2 evaluates the double factorial function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   N   Exact  I_FACTORIAL2(N)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call i_factorial2_values ( n_data, n, fn )

    if ( n_data == 0 ) then
      exit
    end if

    fn2 = i_factorial2 ( n )

    write ( *, '(2x,i4,2i8)' ) n, fn, fn2

  end do

  return
end
subroutine test045
!
!*******************************************************************************
!
!! TEST045 tests I_PARTITION_COUNT_VALUES.
!
  implicit none
!
  integer c
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST045:'
  write ( *, '(a)' ) '  For the number of partitions of an integer,'
  write ( *, '(a)' ) '  I_PARTITION_COUNT_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N       Exact F'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call i_partition_count_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    write ( *, '(2x,2i10)' ) n, c

  end do

  return
end
subroutine test046
!
!*******************************************************************************
!
!! TEST046 tests I_PARTITION_DISTINCT_COUNT.
!! TEST046 tests I_PARTITION_DISTINCT_COUNT_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
  integer, parameter :: n_max = 20
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST046:'
  write ( *, '(a)' ) '  For the number of partitions of an integer'
  write ( *, '(a)' ) '    into distinct parts,'
  write ( *, '(a)' ) '  I_PARTITION_DISTINCT_COUNT'
  write ( *, '(a)' ) '    computes any value.'
  write ( *, '(a)' ) '  I_PARTITION_DISTINCT_COUNT_VALUES '
  write ( *, '(a)' ) '    returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N       Exact F    Q(N)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call i_partition_distinct_count_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    if ( n_max < n ) then
      cycle
    end if

    call i_partition_distinct_count ( n, c2 )

    write ( *, '(2x,3i10)' ) n, c, c2

  end do

  return
end
subroutine test047
!
!*******************************************************************************
!
!! TEST047 tests I_POCHHAMMER.
!
  implicit none
!
  integer i
  integer i_pochhammer
  integer j
  integer k
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST047:'
  write ( *, '(a)' ) '  I_POCHHAMMER evaluates the integer Pochhammer function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   I   J   I_Pochhammer(I,J)'
  write ( *, '(a)' ) ' '

  i = 3
  j = 3
  k = i_pochhammer ( i, j, k )

  write ( *, '(2x,i4,i4,i4)' ) i, j,  k

  i = 3
  j = 4
  k = i_pochhammer ( i, j, k )
  write ( *, '(2x,i4,i4,i4)' ) i, j,  k

  i = 3
  j = 5
  k = i_pochhammer ( i, j, k )
  write ( *, '(2x,i4,i4,i4)' ) i, j,  k

  return
end
subroutine test048
!
!*******************************************************************************
!
!! TEST048 tests I_IS_TRIANGULAR.
!! TEST048 tests I_TO_TRIANGLE.
!! TEST048 tests TRIANGLE_TO_I.
!
  implicit none
!
  integer i
  logical i_is_triangular
  integer i2
  integer j
  integer k
  integer k2
  logical l
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST048'
  write ( *, '(a)' ) '  I_TO_TRIANGLE converts a linear index to a'
  write ( *, '(a)' ) '    triangular one.'
  write ( *, '(a)' ) '  TRIANGLE_TO_I converts a triangular index to a'
  write ( *, '(a)' ) '    linear one.'
  write ( *, '(a)' ) '  I_IS_TRIANGULAR returns T or F depending on'
  write ( *, '(a)' ) '    whether I is triangular.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   I  =>   J   K  =>   I   T/F'
  write ( *, '(a)' ) ' '

  do i = 0, 20

    call i_to_triangle ( i, j, k )

    call triangle_to_i ( j, k, i2 )

    l = i_is_triangular ( i )

    write ( *, '(2x,i4,4x,i4,i4,4x,i4,4x,l1)' )  i, j, k, i2, l

  end do
 
  return
end
subroutine test049
!
!*******************************************************************************
!
!! TEST049 tests JACOBI_POLY.
!! TEST049 tests JACOBI_POLY_VALUES.
!
  implicit none
!
  integer a
  real ( kind = 8 ) alpha
  integer b
  real ( kind = 8 ) beta
  real ( kind = 8 ) c(0:6)
  real ( kind = 8 ) fx
  real fx2
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST049:'
  write ( *, '(a)' ) '  JACOBI_POLY computes values of '
  write ( *, '(a)' ) '    the Jacobi polynomial.'
  write ( *, '(a)' ) '  JACOBI_POLY_VALUES returns values of '
  write ( *, '(a)' ) '    the Jacobi polynomial.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '       N       A       B      X       JPV      JACOBI'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call jacobi_poly_values ( n_data, n, a, b, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    alpha = real ( a )
    beta = real ( b )
    call jacobi_poly ( n, alpha, beta, x, c )
    fx2 = c(n)

    write ( *, '(2x,i6,2x,i6,2x,i6,f10.4,2g14.6)' ) n, a, b, x, fx, fx2

  end do

  return
end
subroutine test050
!
!*******************************************************************************
!
!! TEST050 tests JACOBI_SYMBOL.
!
  implicit none
!
  integer, parameter :: ntest = 4
!
  integer i
  integer l
  integer p
  integer, dimension ( ntest ) :: ptest = (/ 3, 9, 10, 12 /)
  integer q
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST050'
  write ( *, '(a)' ) '  JACOBI_SYMBOL computes the Jacobi symbol'
  write ( *, '(a)' ) '    (Q/P), which records if Q is a quadratic '
  write ( *, '(a)' ) '    residue modulo the number P.'

  do i = 1, ntest
    p = ptest(i)
    write ( *, '(a)' ) ' '
    write ( *, '(a,i6)' ) 'Jacobi Symbols for P = ', p
    write ( *, '(a)' ) ' '
    do q = 0, p
      call jacobi_symbol ( q, p, l )
      write ( *, '(2x,3i8)' ) p, q, l
    end do
  end do

  return
end
subroutine test051
!
!*******************************************************************************
!
!! TEST051 tests LAGUERRE_ASSOCIATED.
!
  implicit none
!
  integer, parameter :: i_test = 6
  integer, parameter :: n = 6
!
  real ( kind = 8 ) c(0:n)
  integer i
  integer j
  integer m
  integer, dimension ( i_test ) :: m_test = (/ 0, 0, 1, 2, 3, 1 /)
  real ( kind = 8 ) x
  real ( kind = 8 ), dimension ( i_test ) :: x_test = (/ &
    0.0D+00, 1.0D+00, 0.0D+00, 0.5D+00, 0.5D+00, 0.5D+00 /)
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST051'
  write ( *, '(a)' ) '  LAGUERRE_ASSOCIATED evaluates the associated Laguerre'
  write ( *, '(a)' ) '  polynomials.'

  do i = 1, i_test

    m = m_test(i)
    x = x_test(i)

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '  Table of L(N,M)(X) for'
    write ( *, '(a)' ) ' '
    write ( *, '(a,i4)' ) '  N(max) = ', n
    write ( *, '(a,i4)' ) '  M      = ', m
    write ( *, '(a,g14.6)' ) '  X =      ', x
    write ( *, '(a)' ) ' '
 
    call laguerre_associated ( n, m, x, c )
 
    do j = 0, n
      write ( *, '(2x,i6,g14.6)' ) j, c(j)
    end do
 
  end do

  return
end
subroutine test052
!
!*******************************************************************************
!
!! TEST052 tests LAGUERRE_GENERAL.
!
  implicit none
!
  integer, parameter :: i_test = 6
  integer, parameter :: n = 10
!
  real ( kind = 8 ) alpha
  real ( kind = 8 ), dimension ( i_test ) :: alpha_test = (/ &
    0.0D+00, 0.0D+00, 0.1D+00, 0.1D+00, 0.5D+00, 1.0D+00 /)
  real ( kind = 8 ) c(0:n)
  integer i
  integer j
  real ( kind = 8 ) x
  real ( kind = 8 ), dimension ( i_test ) :: x_test = (/ &
    0.0D+00, 1.0D+00, 0.0D+00, 0.5D+00, 0.5D+00, 0.5D+00 /)
! 
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST052'
  write ( *, '(a)' ) '  LAGUERRE_GENERAL evaluates the generalized Laguerre '
  write ( *, '(a)' ) '  functions.'

  do i = 1, i_test

    x = x_test(i)
    alpha = alpha_test(i)

    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) '  Table of L(N,ALPHA)(X) for'
    write ( *, '(a)' ) ' '
    write ( *, '(a,i6)' ) '    N(max) = ', n
    write ( *, '(a,g14.6)' ) '    ALPHA =  ', alpha
    write ( *, '(a,g14.6)' ) '    X =      ', x
    write ( *, '(a)' ) ' '
  
    call laguerre_general ( n, alpha, x, c )
 
    do j = 0, n
      write ( *, '(2x,i6,g14.6)' ) j, c(j)
    end do

  end do
 
  return
end
subroutine test054
!
!*******************************************************************************
!
!! TEST054 tests LAGUERRE_POLY.
!! TEST054 tests LAGUERRE_POLY_VALUES.
!
  implicit none
!
  integer, parameter :: n_max = 12
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST054:'
  write ( *, '(a)' ) '  LAGUERRE_POLY evaluates the Laguerre polynomial.'
  write ( *, '(a)' ) '  LAGUERRE_POLY_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       L(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call laguerre_poly_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call laguerre_poly ( n, x, fx2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test055
!
!*******************************************************************************
!
!! TEST055 tests LAGUERRE_POLY_COEF.
!
  implicit none
!
  integer, parameter :: n = 5
!
  real ( kind = 8 ) c(0:n,0:n)
  real ( kind = 8 ) fact
  integer i
  integer j
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST055'
  write ( *, '(a)' ) &
    '  LAGUERRE_POLY_COEF determines the Laguerre polynomial coefficients.'

  call laguerre_poly_coef ( n, c )
 
  do i = 0, n
    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  L(', i, ')'
    write ( *, '(a)' ) ' '
    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) c(i,j), ' * x**', j
      end if
    end do
  end do
 
  fact = 1.0

  do i = 0, n

    if ( 0 < i ) then
      fact = fact * real ( i )
    end if

    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  Factorially scaled L(', i, ')'
    write ( *, '(a)' ) ' '

    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) fact * c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) fact * c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) fact * c(i,j), ' * x**', j
      end if
    end do
    
  end do

  return
end
subroutine test057
!
!*******************************************************************************
!
!! TEST057 tests LEGENDRE_POLY.
!! TEST057 tests LEGENDRE_POLY_VALUES.
!
  implicit none
!
  integer, parameter :: n_max = 12
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fp2(0:n_max)
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST057:'
  write ( *, '(a)' ) '  LEGENDRE_POLY evaluates the Legendre PN function.'
  write ( *, '(a)' ) '  LEGENDRE_POLY_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       P(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call legendre_poly_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call legendre_poly ( n, x, fx2, fp2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test058
!
!*******************************************************************************
!
!! TEST058 tests LEGENDRE_POLY_COEF.
!
  implicit none
!
  integer, parameter :: n = 5
!
  real ( kind = 8 ) c(0:n,0:n)
  integer i
  integer j
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST058'
  write ( *, '(a)' ) &
    '  LEGENDRE_POLY_COEF returns Legendre polynomial coefficients.'

  call legendre_poly_coef ( n, c )
 
  do i = 0, n
    write ( *, '(a)' ) ' '
    write ( *, '(a,i2,a)' ) '  P(', i, ')'
    write ( *, '(a)' ) ' '
    do j = i, 0, -1
      if ( j == 0 ) then
        write ( *, '(2x,g14.6)' ) c(i,j)
      else if ( j == 1 ) then
        write ( *, '(2x,g14.6,a)' ) c(i,j), ' * x'
      else
        write ( *, '(2x,g14.6,a,i2)' ) c(i,j), ' * x**', j
      end if
    end do
  end do

  return
end
subroutine test059
!
!*******************************************************************************
!
!! TEST059 tests LEGENDRE_ASSOCIATED.
!! TEST059 tests LEGENDRE_ASSOCIATED_VALUES.
!
  implicit none
!
  integer, parameter :: n_max = 20
!
  real ( kind = 8 ) fx2(0:n_max)
  real ( kind = 8 ) fx
  integer m
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST059:'
  write ( *, '(a)' ) '  LEGENDRE_ASSOCIATED evaluates associated Legrendre functions.'
  write ( *, '(a)' ) '  LEGENDRE_ASSOCIATED_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '      N       M    X     Exact F     PNM(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call legendre_associated_values ( n_data, n, m, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call legendre_associated ( n, m, x, fx2 )

    write ( *, '(2x,i8,i8,f8.4,2g14.6)' ) n, m, x, fx, fx2(n)

  end do

  return
end
subroutine test060
!
!*******************************************************************************
!
!! TEST060 tests LEGENDRE_FUNCTION_Q.
!! TEST060 tests LEGENDRE_FUNCTION_Q_VALUES.
!
  implicit none
!
  integer, parameter :: n_max = 12
!
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2(0:n_max)
  integer n
  integer n_data
  real ( kind = 8 ) x
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST060:'
  write ( *, '(a)' ) '  LEGENDRE_FUNCTION_Q evaluates the Legendre Q function.'
  write ( *, '(a)' ) '  LEGENDRE_FUNCTION_Q_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N      X        Exact F       Q(N)(X)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call legendre_function_q_values ( n_data, n, x, fx )

    if ( n_data == 0 ) then
      exit
    end if

    call legendre_function_q ( n, x, fx2 )

    write ( *, '(2x,i8,f8.4,2g14.6)' ) n, x, fx, fx2(n)

  end do

  return
end
subroutine test061
!
!*******************************************************************************
!
!! TEST061 tests LEGENDRE_SYMBOL.
!
  implicit none
!
  integer, parameter :: ntest = 4
!
  integer i
  integer l
  integer p
  integer, dimension ( ntest ) :: ptest = (/ 7, 11, 13, 17 /)
  integer q
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST061'
  write ( *, '(a)' ) '  LEGENDRE_SYMBOL computes the Legendre'
  write ( *, '(a)' ) '    symbol (Q/P) which records whether Q is '
  write ( *, '(a)' ) '    a quadratic residue modulo the prime P.'

  do i = 1, ntest
    p = ptest(i)
    write ( *, '(a)' ) ' '
    write ( *, '(a,i6)' ) 'Legendre Symbols for P = ', p
    write ( *, '(a)' ) ' '
    do q = 0, p
      call legendre_symbol ( q, p, l )
      write ( *, '(2x,3i8)' ) p, q, l
    end do
  end do

  return
end
subroutine test062
!
!*******************************************************************************
!
!! TEST062 tests LOCK.
!
  implicit none
!
  integer, parameter :: n = 10
!
  integer a(0:n)
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST062'
  write ( *, '(a)' ) '  LOCK counts the combinations on a button lock.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I,  LOCK(I)'
  write ( *, '(a)' ) ' '

  call lock ( n, a )

  do i = 0, n
    write ( *, '(2x,i4,2x,i10)' )  i, a(i)
  end do
 
  return
end
subroutine test063
!
!*******************************************************************************
!
!! TEST063 tests MOEBIUS.
!! TEST063 tests MOEBIUS_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST063'
  write ( *, '(a)' ) '  MOEBIUS computes the Moebius function.'
  write ( *, '(a)' ) '  MOEBIUS_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N   Exact   MOEBIUS(N)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call moebius_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call moebius ( n, c2 )

    write ( *, '(2x,i4,2i10)' ) n, c, c2

  end do
 
  return
end
subroutine test0635
!
!*******************************************************************************
!
!! TEST0635 tests MOTZKIN.
!
  implicit none
!
  integer, parameter :: n = 10
!
  integer a(0:n)
  integer i
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0635'
  write ( *, '(a)' ) '  MOTZKIN computes the Motzkin numbers A(0:N).'
  write ( *, '(a)' ) '  A(N) counts the paths from (0,0) to (N,0).'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  I,  A(I)'
  write ( *, '(a)' ) ' '

  call motzkin ( n, a )

  do i = 0, n
    write ( *, '(2x,i4,2x,i10)' )  i, a(i)
  end do
 
  return
end
subroutine test064
!
!*******************************************************************************
!
!! TEST064 tests OMEGA.
!! TEST064 tests OMEGA_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST064'
  write ( *, '(a)' ) '  OMEGA counts the distinct prime divisors of an integer N.'
  write ( *, '(a)' ) '  OMEGA_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '          N   Exact   OMEGA(N)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call omega_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call omega ( n, c2 )

    write ( *, '(2x,i12,2i10)' ) n, c, c2

  end do
 
  return
end
subroutine test065
!
!*******************************************************************************
!
!! TEST065 tests PENTAGON_NUM.
!
  implicit none
!
  integer n
  integer p
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST065'
  write ( *, '(a)' ) '  PENTAGON_NUM computes the pentagonal numbers.'
  write ( *, '(a)' ) ' '
 
  do n = 1, 10
    call pentagon_num ( n, p )
    write ( *, '(2x,i4,2x,i6)' ) n, p
  end do
 
  return
end
subroutine test066
!
!*******************************************************************************
!
!! TEST066 tests PHI.
!! TEST066 tests PHI_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST066'
  write ( *, '(a)' ) '  PHI computes the PHI function.'
  write ( *, '(a)' ) '  PHI_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N   Exact   PHI(N)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call phi_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call phi ( n, c2 )

    write ( *, '(2x,i4,2i10)' ) n, c, c2

  end do
 
  return
end
subroutine test067
!
!*******************************************************************************
!
!! TEST067 tests PYRAMID_NUM.
!
  implicit none
!
  integer n
  integer pyramid_num
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST067'
  write ( *, '(a)' ) '  PYRAMID_NUM computes the pyramidal numbers.'
  write ( *, '(a)' ) ' '
 
  do n = 1, 10
    write ( *, '(2x,i4,2x,i6)' ) n, pyramid_num ( n )
  end do
 
  return
end
subroutine test0685
!
!*******************************************************************************
!
!! TEST0685 tests D_FACTORIAL_LOG.
!! TEST0685 tests D_FACTORIAL_LOG_VALUES.
!
  implicit none
!
  real ( kind = 8 ) fn
  real ( kind = 8 ) fn2
  real ( kind = 8 ) d_factorial_log
  integer n_data
  integer n
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0685:'
  write ( *, '(a)' ) '  D_FACTORIAL_LOG evaluates the logarithm of the '
  write ( *, '(a)' ) '    factorial function.'
  write ( *, '(a)' ) '  D_FACTORIAL_LOG_VALUES returns some exact values.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N	   Exact F	 D_FACTORIAL_LOG(N)'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call d_factorial_log_values ( n_data, n, fn )

    if ( n_data == 0 ) then
      exit
    end if

    fn2 = d_factorial_log ( n )

    write ( *, '(2x,i5,2g14.6)' ) n, fn, fn2

  end do

  return
end
subroutine test069
!
!*******************************************************************************
!
!! TEST069 tests SIGMA.
!! TEST069 tests SIGMA_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST069'
  write ( *, '(a)' ) '  SIGMA computes the SIGMA function.'
  write ( *, '(a)' ) '  SIGMA_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N   Exact   SIGMA(N)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call sigma_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call sigma ( n, c2 )

    write ( *, '(2x,i4,2i10)' ) n, c, c2

  end do
 
  return
end
subroutine test0695
!
!*******************************************************************************
!
!! TEST0695 demonstrates the use of SIN_POWER_INT_VALUES.
!
  implicit none
!
  real ( kind = 8 ) a
  real ( kind = 8 ) b
  real ( kind = 8 ) fx
  real ( kind = 8 ) fx2
  integer n
  integer n_data
  real ( kind = 8 ) sin_power_int
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST0695:'
  write ( *, '(a)' ) '  SIN_POWER_INT returns values of '
  write ( *, '(a)' ) '  the integral of SIN(X)^N from A to B.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) &
    '      A         B          N      Exact           Computed'
  write ( *, '(a)' ) ' '

  n_data = 0

  do

    call sin_power_int_values ( n_data, a, b, n, fx )

    if ( n_data == 0 ) then
      exit
    end if

    fx2 = sin_power_int ( a, b, n )

    write ( *, '(2x,f8.4,2x,f8.4,2x,i6,2x,g14.6,2x,g14.6)' ) a, b, n, fx, fx2

  end do

  return
end
subroutine test070
!
!*******************************************************************************
!
!! TEST070 tests STIRLING1.
!
  implicit none
!
  integer, parameter :: m = 8
  integer, parameter :: n = m
!
  integer i
  integer j
  integer s1(m,n)
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST070'
  write ( *, '(a)' ) '  STIRLING1: Stirling numbers of first kind.'
  write ( *, '(a,i4)' ) '  Get rows 1 through ', m
  write ( *, '(a)' ) ' '
 
  call stirling1 ( m, n, s1 )
 
  do i = 1, m
    write ( *, '(2x,i6,8i8)' ) i, s1(i,1:n)
  end do
 
  return
end
subroutine test071
!
!*******************************************************************************
!
!! TEST071 tests STIRLING2.
!
  implicit none
!
  integer, parameter :: m = 8
  integer, parameter :: n = m
!
  integer i
  integer j
  integer s2(m,n)
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST071'
  write ( *, '(a)' ) '  STIRLING2: Stirling numbers of second kind.'
  write ( *, '(a,i4)' ) '  Get rows 1 through ', m
  write ( *, '(a)' ) ' '
 
  call stirling2 ( m, n, s2 )
 
  do i = 1, m
    write ( *, '(2x,i6,8i8)' ) i, s2(i,1:n)
  end do
 
  return
end
subroutine test072
!
!*******************************************************************************
!
!! TEST072 tests TAU.
!! TEST072 tests TAU_VALUES.
!
  implicit none
!
  integer c
  integer c2
  integer n
  integer n_data
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST072'
  write ( *, '(a)' ) '  TAU computes the Tau function.'
  write ( *, '(a)' ) '  TAU_VALUES returns some exact values.'
  write ( *, '(a)' ) ' ' 
  write ( *, '(a)' ) '  N  exact C(I)  computed C(I)'
  write ( *, '(a)' ) ' '
 
  n_data = 0

  do

    call tau_values ( n_data, n, c )

    if ( n_data == 0 ) then
      exit
    end if

    call tau ( n, c2 )

    write ( *, '(2x,i4,2i10)' ) n, c, c2

  end do
 
  return
end
subroutine test073
!
!*******************************************************************************
!
!! TEST073 tests TETRAHEDRON_NUM.
!
  implicit none
!
  integer n
  integer tetrahedron_num
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST073'
  write ( *, '(a)' ) '  TETRAHEDRON_NUM computes the tetrahedron numbers.'
  write ( *, '(a)' ) ' '
 
  do n = 1, 10
    write ( *, '(2x,i4,2x,i6)' ) n, tetrahedron_num ( n )
  end do
 
  return
end
subroutine test074
!
!*******************************************************************************
!
!! TEST074 tests TRIANGLE_NUM.
!
  implicit none
!
  integer n
  integer triangle_num
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST074'
  write ( *, '(a)' ) '  TRIANGLE_NUM computes the triangular numbers.'
  write ( *, '(a)' ) ' '
 
  do n = 1, 10
    write ( *, '(2x,i4,2x,i6)' ) n, triangle_num ( n )
  end do
 
  return
end
subroutine test075
!
!*******************************************************************************
!
!! TEST075 tests V_HOFSTADTER.
!
  implicit none
!
  integer i
  integer v
  integer v_hofstadter
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST075'
  write ( *, '(a)' ) '  V_HOFSTADTER evaluates Hofstadter''s recursive'
  write ( *, '(a)' ) '  V function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '     N   V(N)'
  write ( *, '(a)' ) ' '

  do i = 0, 30
    v = v_hofstadter ( i )
    write ( *, '(2x,2i6)' ) i, v
  end do

  return
end
subroutine test076
!
!*******************************************************************************
!
!! TEST076 tests VIBONACCI.
!
  implicit none
!
  integer, parameter :: n = 20
  integer, parameter :: n_time = 3
!
  integer i
  integer j
  integer seed
  integer v(n,n_time)
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST076'
  write ( *, '(a)' ) '  VIBONACCI computes a Vibonacci sequence.'
  write ( *, '(a)' ) ' '
  write ( *, '(a,i4)' ) '  Number of times we compute the series: ', n_time
  write ( *, '(a)' ) ' '

  seed = 123456789

  do j = 1, n_time
    call vibonacci ( n, seed, v(1,j) ) 
  end do

  do i = 1, n
    write ( *, '(2x,i6,3i6)' ) i, v(i,1:n_time)
  end do
 
  return
end
subroutine test077
!
!*******************************************************************************
!
!! TEST077 tests ZECKENDORF.
!
  implicit none
!
  integer, parameter :: m_max = 20
!
  integer i
  integer i_list(m_max)
  integer f_list(m_max)
  integer f_sum
  integer m
  integer n
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST077'
  write ( *, '(a)' ) '  ZECKENDORF computes the Zeckendorf decomposition of'
  write ( *, '(a)' ) '  an integer N into nonconsecutive Fibonacci numbers.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '   N Sum M Parts'
  write ( *, '(a)' ) ' '

  do n = 1, 100

    call zeckendorf ( n, m_max, m, i_list, f_list )

    write ( *, '(2x,i4,2x,15i4)' ) n, f_list(1:m)

  end do

  return
end
subroutine test078
!
!*******************************************************************************
!
!! TEST078 tests ZETA.
!
  implicit none
!
  integer i
  real ( kind = 8 ) p
  real ( kind = 8 ) z
  real ( kind = 8 ) zeta
!
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST078'
  write ( *, '(a)' ) '  ZETA evaluates the Riemann Zeta function.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '    P    Zeta(P)'
  write ( *, '(a)' ) ' '

  do i = 2, 15
    p = real ( i, kind = 8 )
    z = zeta ( p )
    write ( *, '(2x,f6.2,2x,g24.16)' ) p, z
  end do
 
  return
end
