program qspline

  implicit none
  integer,parameter :: rk=selected_real_kind(15,100)

  real(rk),allocatable :: xa(:),ya(:),z(:)
  real(rk) ::  x,y,x1,x2,dx,Qp0
  integer :: n,i,j,ix,ixmax
  character(len=80) :: argu

  if (iargc()/=4) then
     call getarg(0,argu)
     write(0,'(a,a,a)') 'usage: ',trim(argu),' x1 x2 dx Qp0'
     stop
  end if

  call getarg(1,argu); read(argu,*) x1
  call getarg(2,argu); read(argu,*) x2
  call getarg(3,argu); read(argu,*) dx
  call getarg(4,argu); read(argu,*) Qp0

  read(5,*) n
  allocate(xa(0:n),ya(0:n),z(0:n))
  do i=0,n-1
     read(5,*) xa(i),ya(i)
  end do
  n=n-1

  z(0)=Qp0
  do i=0,n-1
     z(i+1)=-z(i)+2.0*(ya(i+1)-ya(i))/(xa(i+1)-xa(i))
  end do

  ixmax=(x2-x1)/dx
  
  do ix=0,ixmax
     x=x1+dx*ix
     if (x<xa(0).or.x>xa(n)) cycle
     do i=0,n-1
        if (x>=xa(i).and.x<xa(i+1)) exit
     end do
     y=(z(i+1)-z(i))/2/(xa(i+1)-xa(i))*(x-xa(i))**2+z(i)*(x-xa(i))+ya(i)
     write(6,*) x,y
  end do

  stop
end program qspline
  
