program spline_slatec

  implicit none
  integer,parameter :: rk=selected_real_kind(15,100)

  real(rk),allocatable :: xa(:),ya(:),w(:),t(:),bcoef(:)
  real(rk) ::  x,y,x1,x2,dx,fbcl,fbcr
  integer :: ibcl,ibcr,kntopt,ncoef,k,ideriv,inbv
  integer :: n,i,j,ix,ixmax
  character(len=80) :: argu
  real(rk),external :: dbvalu

  if (iargc()/=3) then
     call getarg(0,argu)
     write(0,'(a,a,a)') 'usage: ',trim(argu),' x1 x2 dx'
     stop
  end if

  call getarg(1,argu); read(argu,*) x1
  call getarg(2,argu); read(argu,*) x2
  call getarg(3,argu); read(argu,*) dx

  read(5,*) n
  allocate(xa(1:n),ya(1:n),w(1:5*(n+2)),t(1:n+4),bcoef(1:n+2))
  do i=1,n
     read(5,*) xa(i),ya(i)
  end do
  n=n-1

  ibcl=2
  ibcr=2
  fbcl=0.0
  fbcr=0.0
  kntopt=2
  k=4
  w=0.0

  call dbint4(xa,ya,n,ibcl,ibcr,fbcl,fbcr,kntopt,t,bcoef,ncoef,k,w)

  ixmax=(x2-x1)/dx

  ideriv=0
  inbv=1

  do ix=1,ixmax
     x=x1+dx*ix
     y=dbvalu(t,bcoef,n,k,ideriv,x,inbv,w)
     write(6,*) x,y
  end do

  stop
end program spline_slatec
  
